#include <stdio.h>
#include <stdlib.h>
#include <string.h>

 /* Programa partidor de ficheros */
 /* Parte un fichero en paquetes de tamanyo especificado */
 /* para transferirlo */
 /* a disquetes u otros dispositivos */
 /* de El Presi [Enrique D. Bosch] */
 /* Version 2.9p, multiplataforma en ansi C */
 /* Este programa se acoge a la licencia GNU GPL, mas info: www.fsf.org */


FILE *abrirfich(char nom[],char *modo,char *error);
void salir(char *me);
unsigned long int capvalor(char nupaopmas1, int argc, char *nota, char *seguir, char *argv[]);
void elimpunto(char *cadd,char *cad);

int main(int argc, char *argv[])
 {

   FILE *ff,*fd,*fb,*fbu;
   char a,nomfuen[256],nombase[256],nomnu[256],nomcons[256],num[7],nomaux[256],
        nomaux2[8],cadcon[16],cadconu[16],nomaux3[8],nomauxf[256],
        nomfuenaux[18],nomfuentrunc[18],nomaux4[18],*extant,*extantf,
        ex,nupaop,nuopc,opc, 
        s = 0, v = 0, u = 0, n = 0, d = 0, t = 0, j = 0, ju = 0,
        nota = 1, seguir = 1,londigit = 0;
   unsigned long int tam,resto;
   unsigned short int veces,numarchs,x;
   fpos_t tamff;


   if ( argc<2 || (argc==2 && !strcmp(argv[1],"-h")) )
     {
       fputs("Programa partidor de ficheros de El Presi v2.9p\nEste programa se acoge la licencia GNU GPL, mas info: www.fsf.org\nUtilizacion: part -D|-e|-X|-E|-b|-k|-q|-m|-M n [-v][-t][-d][-s][-j][-J]\n",stderr);
       fputs("                  [-u|-n] (fichero fuente) [(nombre base fichero destino)]\n",stderr);
       fputs("             part -h\n             part -V\n",stderr);
       exit(0);
     }

   if ( argc==2 && !strcmp(argv[1],"-V") )
     {
       fputs("part v2.9p\n",stderr);
       exit(0);
     }

         /* Captura y comprobacion de opciones en linea de comando */

   for (nupaop = 1; nupaop<argc && argv[nupaop][0]=='-'; nupaop++, seguir = 1)
      for (nuopc = 1; ( opc = argv[nupaop][nuopc] )!='\0' && seguir; nuopc++)
        switch (opc)
          {
            case 'D':if (nota)
                      {
                        tam = 1457664;
                        nota = 0;
                      }
                     else salir("part: opcion de tamanyo duplicada\n");
                     break;
            case 'e':if (nota)
                      {
                        tam = 1456640;
                        nota = 0;
                      }
                     else salir("part: opcion de tamanyo duplicada\n");
                     break;
            case 'X':if (nota)
                      {
                        tam = 1464320;
                        nota = 0;
                      }
                     else salir("part: opcion de tamanyo duplicada\n");
                     break;
            case 'E':if (nota)
                      {
                        tam = 1462272;
                        nota = 0;
                      }
                     else salir("part: opcion de tamanyo duplicada\n");
                     break;
            case 'b':tam = capvalor(++nupaop,argc,&nota,&seguir,argv);
                     break;
            case 'k':tam = 1024*capvalor(++nupaop,argc,&nota,&seguir,argv);
                     break;
            case 'q':tam = 1000*capvalor(++nupaop,argc,&nota,&seguir,argv);
                     break;
            case 'm':tam = 1048576*capvalor(++nupaop,argc,&nota,&seguir,argv);
                     break;
            case 'M':tam = 1000000*capvalor(++nupaop,argc,&nota,&seguir,argv);
                     break;
            case 'v':v = 1;
                     break;
            case 'd':d = 1;
                     break;
            case 't':t = 1;
                     d = 1;
                     break;
            case 's':s = 1;
                     break;
            case 'u':if (n) salir("part: opciones -u y -n no pueden ir juntas\n");
                     u = 1;
                     break;
            case 'n':if (u) salir("part: opciones -u y -n no pueden ir juntas\n");
                     n = 1;
                     break;
            case 'j':j = 1;
                     break;
            case 'J':ju = 1;
                     break;
            default:salir("part: error en las opciones\n");
          }
          
   if (nota) salir("part: no se ha especificado el tamanyo de los fragmentos\n");

    /* Captura del nombre del fichero fuente y base desde linea de comando */
    /* o utiliza entrada estandar */
   
   if (argc==nupaop) salir("part: no se ha especificado nombre de fichero\n");
   else
    {
      if ( strlen(argv[nupaop])<256 ) strcpy(nomfuen,argv[nupaop]);
                                 else salir("part: nombre de fichero demasiado largo\n");

      if ((nupaop+1)==argc) strcpy(nombase,nomfuen);
                       else if ( strlen(argv[++nupaop])<256 ) strcpy(nombase,argv[nupaop]);
                            else salir("part: nombre de fichero demasiado largo\n");

      ff = abrirfich(nomfuen,"rb","part: error al abrir fichero fuente\n");
      
      if (j)     /* Crear fichero bat de DOS para re-juntar */
       {
         fb = abrirfich("juntar.bat","w","part: error al abrir fichero bat\n");
         fputs("copy /b ",fb);
         
         /* Creacion del nombre fuente truncado para fichero juntar.bat */

         strcpy(nomauxf,nomfuen);
       
          /* extraccion de la extension (tipo del fichero) anterior (de nomfuen) */

          if ( (extantf = strrchr(nomauxf,'.'))==NULL ) nomaux3[0] = '\0';
          else
            {  
               for (ex = 1; ex<=3; ex++) if ( *(extantf+ex)=='.' ) 
                                             {  *(extantf+ex) = '\0'; break; }

               *(extantf+4) = '\0';
               
               strcpy(nomaux3,extantf);
            }
         if (extantf!=NULL) *extantf = '\0';
         strncpy(nomfuenaux,nomauxf,16);
         nomfuenaux[16] = '\0';
         elimpunto(nomfuentrunc,nomfuenaux);
         nomfuentrunc[8] = '\0';
         strcat(nomfuentrunc,nomaux3);

       }
      
      if (ju)  /* Crear fichero de script de shell Unix para re-juntar */
       {
         fbu = abrirfich("juntar","w","part: error al creando script\n");
         fputs("cat ",fbu);
       }

    }

      /* Comprobacion del tamanyo y numero de fragmentos */

   fseek(ff,0,SEEK_END);
   fgetpos(ff,&tamff);
   rewind(ff);
   
   {
     unsigned long int vec;
   
     if ( (vec = tamff/tam)>65535 ) salir("part: demasiados ficheros fragmento\n");
   
     veces = vec;
   }

   if (veces<1) salir("part: !el tamanyo de particion es mas grande que el fichero!\n");

   resto = tamff%tam;

   if (resto) numarchs = veces+1;
         else numarchs = veces;

     /* Construccion de los sufijos */

   if (!d)
     {
        strcpy(nomcons,nombase);
     
        if (numarchs<100)
          { 
            strcpy(cadcon,".p%02d");
            strcpy(cadconu,".p%02du");
          }
        else if (numarchs<1000)
               {
                 strcpy(cadcon,".p%03d");
                 strcpy(cadconu,".p%03du");
               }
             else if (numarchs<10000)
                    {
                      strcpy(cadcon,".p%04d");
                      strcpy(cadconu,".p%04du");
                    }
                  else
                    { 
                      strcpy(cadcon,".p%05d");
                      strcpy(cadconu,".p%05du");
                    }
     }
   else
     {
       strcpy(nomaux,nombase);
       
      /* extraccion de la extension (tipo del fichero) anterior (de nombase) */

          if ( (extant = strrchr(nomaux,'.'))==NULL ) nomaux2[0] = '\0';
          else
            {  
               for (ex = 1; ex<=3; ex++) if ( *(extant+ex)=='.' ) 
                                             {  *(extant+ex) = '\0'; break; }

               *(extant+4) = '\0';
               
               strcpy(nomaux2,extant);
            }

                 /* Creacion de los modelos de nombre DOS */

       if (numarchs<100)
          if (t)
            {
              char nomconsaux[256];
             
              strcpy(cadcon,".p%02d");
              strcpy(cadconu,"u.p%02d");
              strncpy(nomconsaux,nomaux,16);
              nomconsaux[16] = '\0';
              elimpunto(nomcons,nomconsaux);
              nomcons[8] = '\0';
              londigit = 0;
            }
          else
            { 
              strcpy(cadcon,"%02d");
              strcat(cadcon,nomaux2);
              strcpy(cadconu,"%02du");
              strcat(cadconu,nomaux2);
              if (extant!=NULL) *extant = '\0';
              strncpy(nomaux4,nomaux,16);
              nomaux4[16] = '\0';
              elimpunto(nomcons,nomaux4);
              nomcons[6] = '\0';
              londigit = 2;
            }
       else if (numarchs<1000)
              {
                strcpy(cadcon,"%03d");
                strcat(cadcon,nomaux2);
                strcpy(cadconu,"%03du");
                strcat(cadconu,nomaux2);
                if (extant!=NULL) *extant = '\0';
                strncpy(nomaux4,nomaux,16);
                nomaux4[16] = '\0';
                elimpunto(nomcons,nomaux4);
                nomcons[5] = '\0';
                londigit = 3;
              }
            else if (numarchs<10000)
                   {
                     strcpy(cadcon,"%04d");
                     strcat(cadcon,nomaux2);
                     strcpy(cadconu,"%04du");
                     strcat(cadconu,nomaux2);
                     if (extant!=NULL) *extant = '\0';
                     strncpy(nomaux4,nomaux,16);
                     nomaux4[16] = '\0';
                     elimpunto(nomcons,nomaux4);
                     nomcons[4] = '\0';
                     londigit = 4;
                   }
                 else
                   { 
                     strcpy(cadcon,"%05d");
                     strcat(cadcon,nomaux2);
                     strcpy(cadconu,"%05du");
                     strcat(cadconu,nomaux2);
                     if (extant!=NULL) *extant = '\0';
                     strncpy(nomaux4,nomaux,16);
                     nomaux4[16] = '\0';
                     elimpunto(nomcons,nomaux4);
                     nomcons[3] = '\0';
                     londigit = 5;
                   }
     }

      /* Creacion de los ficheros fragmento */
           
   for (x = 1; x<=veces; x++)
     {       
       strcpy(nomnu,nomcons);

       if ( x==veces && !resto && !n)  /* si es el ultimo y no hay resto, */
         {                      /* poner la u excepto si activada opcion -n */
           char larg;
         
           sprintf(num,cadconu,x);
           if ( d && ((larg = strlen(nomnu))+londigit)==8 ) nomnu[larg-1] = '\0';
         }
       else sprintf(num,cadcon,x);

       if ( (strlen(nomnu)+strlen(num))>255 ) salir("part: nombre de fichero destino demasiado largo\n");

       strcat(nomnu,num);
       
       fd = abrirfich(nomnu,"wb","part: error al abrir un fichero destino\n");
       
       if (v) puts(nomnu);
       
       if (j) fprintf(fb,"%s+",nomnu);      /* Escribiendo fichero bat */
       if (ju) fprintf(fbu,"%s ",nomnu);    /* y/o script de shell */

       if (s)
         {
           unsigned long int y;

           for (y = 1; y<=tam; y++)
            {
              a = fgetc(ff);
              fputc(a,fd);
            }
         }
       else
         {
           char *buf;
           
           if ( (buf = malloc(tam+1))==NULL ) salir("part: no hay memoria suficiente\n");

           if ( fread(buf,1,tam,ff)!=tam ) salir("part: error leyendo fichero de entrada\n");
           
           if ( fwrite(buf,1,tam,fd)!=tam ) salir("part: error escribiendo fichero de salida\n");
           
           free(buf);
         }

       fclose(fd);
       
     }
   
   if (resto)    /* si existe resto crear ultimo fichero */
     {  
       strcpy(nomnu,nomcons);
       
       if (u) { 
                char larg;

                sprintf(num,cadconu,x);
                if ( d && ((larg = strlen(nomnu))+londigit)==8 ) nomnu[larg-1] = '\0';
              }
       else sprintf(num,cadcon,x);

       if ( (strlen(nomnu)+strlen(num))>255 ) salir("part: nombre de fichero destino demasiado largo\n");
       
       strcat(nomnu,num);
   
       fd = abrirfich(nomnu,"wb","part: error al abrir un fichero destino\n");

       if (v) puts(nomnu);
       
       if (j) fprintf(fb,"%s ",nomnu);    /* Escribiendo fichero bat */
       if (ju) fprintf(fbu,"%s ",nomnu);  /* y/o script de shell */

       if (s)
         {
           unsigned long int y;

           for (y = 1; y<=resto; y++)
             {
               a = fgetc(ff);
               fputc(a,fd);
             }
         }
       else
         {
           char *buf;

           if ( (buf = malloc(resto+1))==NULL ) salir("part: no hay memoria suficiente\n");

           if ( fread(buf,1,resto,ff)!=resto ) salir("part: error leyendo fichero de entrada\n");
           
           if ( fwrite(buf,1,resto,fd)!=resto ) salir("part: error escribiendo fichero de salida\n");
           
           free(buf);
         }
   
       fclose(fd);
     }
   
   if (j)
    {
      fprintf(fb,"%s",nomfuentrunc); /* Escribiendo y cerrando fichero bat */
      fclose(fb);
    }

   if (ju)
    {
      fprintf(fbu,"> %s\n",nomfuen);  /* Escribiendo y cerrando fichero */
      fclose(fbu);                    /* shell script */
    }
       
   fclose(ff);
   
   return 0;  
 }


FILE *abrirfich(char nom[],char *modo,char *error)

  /* abrir fichero */

 { 
   FILE *fich;

   if ( ( fich = fopen(nom,modo))==NULL ) salir(error);

   return fich;
 } 


void salir(char *me)

  /* mostrar mensaje de error y salir */

 {
   fputs(me,stderr);
   exit(1);
 }

unsigned long int capvalor(char nupaopmas1, int argc, char *nota, char *seguir, char *argv[])
 {
   char *fin;
   unsigned long int tam;
   
   if (*nota)
      if (nupaopmas1<argc)
         if ( (tam = strtoul(argv[nupaopmas1],&fin,0))==0 ) salir("part: valor de tamanyo erroneo\n");
         else 
           {  *nota = *seguir = 0;
              return tam;
           }
      else salir("part: falta el valor del tamanyo\n");
   else salir("part: opcion de tamanyo duplicada\n");
 }

void elimpunto(char *cadd,char *cad)
 {
   unsigned char i,j;
   char a;
 
   for (i = 0, j = 0; ( a = *(cad+i) )!='\0'; i++) if (a!='.') *(cadd+j++) = a;
   *(cadd+j) = '\0';
 }
